# This Python file uses the following encoding: utf-8
"""autogenerated by genpy from clober_msgs/ControllerState.msg. Do not edit."""
import codecs
import sys
python3 = True if sys.hexversion > 0x03000000 else False
import genpy
import struct


class ControllerState(genpy.Message):
  _md5sum = "46115f277b346cab22c277896530f4f8"
  _type = "clober_msgs/ControllerState"
  _has_header = False  # flag to mark the presence of a Header object
  _full_text = """# The voltage from the main battery (V)
float64 battery_voltage

# The voltage from the charger (V)
float64 charging_voltage

# The current from the 12V user power (A)
float64 current_12v

# The current from the 24V user power (A)
float64 current_24v

# Internal temperature of the motor controller (C)
float64 temperature 

# The state of the controller fault conditions
string[] fault_flags   

# The state of the emergency stop switch on the controller
bool emergency_stop"""
  __slots__ = ['battery_voltage','charging_voltage','current_12v','current_24v','temperature','fault_flags','emergency_stop']
  _slot_types = ['float64','float64','float64','float64','float64','string[]','bool']

  def __init__(self, *args, **kwds):
    """
    Constructor. Any message fields that are implicitly/explicitly
    set to None will be assigned a default value. The recommend
    use is keyword arguments as this is more robust to future message
    changes.  You cannot mix in-order arguments and keyword arguments.

    The available fields are:
       battery_voltage,charging_voltage,current_12v,current_24v,temperature,fault_flags,emergency_stop

    :param args: complete set of field values, in .msg order
    :param kwds: use keyword arguments corresponding to message field names
    to set specific fields.
    """
    if args or kwds:
      super(ControllerState, self).__init__(*args, **kwds)
      # message fields cannot be None, assign default values for those that are
      if self.battery_voltage is None:
        self.battery_voltage = 0.
      if self.charging_voltage is None:
        self.charging_voltage = 0.
      if self.current_12v is None:
        self.current_12v = 0.
      if self.current_24v is None:
        self.current_24v = 0.
      if self.temperature is None:
        self.temperature = 0.
      if self.fault_flags is None:
        self.fault_flags = []
      if self.emergency_stop is None:
        self.emergency_stop = False
    else:
      self.battery_voltage = 0.
      self.charging_voltage = 0.
      self.current_12v = 0.
      self.current_24v = 0.
      self.temperature = 0.
      self.fault_flags = []
      self.emergency_stop = False

  def _get_types(self):
    """
    internal API method
    """
    return self._slot_types

  def serialize(self, buff):
    """
    serialize message into buffer
    :param buff: buffer, ``StringIO``
    """
    try:
      _x = self
      buff.write(_get_struct_5d().pack(_x.battery_voltage, _x.charging_voltage, _x.current_12v, _x.current_24v, _x.temperature))
      length = len(self.fault_flags)
      buff.write(_struct_I.pack(length))
      for val1 in self.fault_flags:
        length = len(val1)
        if python3 or type(val1) == unicode:
          val1 = val1.encode('utf-8')
          length = len(val1)
        buff.write(struct.Struct('<I%ss'%length).pack(length, val1))
      _x = self.emergency_stop
      buff.write(_get_struct_B().pack(_x))
    except struct.error as se: self._check_types(struct.error("%s: '%s' when writing '%s'" % (type(se), str(se), str(locals().get('_x', self)))))
    except TypeError as te: self._check_types(ValueError("%s: '%s' when writing '%s'" % (type(te), str(te), str(locals().get('_x', self)))))

  def deserialize(self, str):
    """
    unpack serialized message in str into this message instance
    :param str: byte array of serialized message, ``str``
    """
    if python3:
      codecs.lookup_error("rosmsg").msg_type = self._type
    try:
      end = 0
      _x = self
      start = end
      end += 40
      (_x.battery_voltage, _x.charging_voltage, _x.current_12v, _x.current_24v, _x.temperature,) = _get_struct_5d().unpack(str[start:end])
      start = end
      end += 4
      (length,) = _struct_I.unpack(str[start:end])
      self.fault_flags = []
      for i in range(0, length):
        start = end
        end += 4
        (length,) = _struct_I.unpack(str[start:end])
        start = end
        end += length
        if python3:
          val1 = str[start:end].decode('utf-8', 'rosmsg')
        else:
          val1 = str[start:end]
        self.fault_flags.append(val1)
      start = end
      end += 1
      (self.emergency_stop,) = _get_struct_B().unpack(str[start:end])
      self.emergency_stop = bool(self.emergency_stop)
      return self
    except struct.error as e:
      raise genpy.DeserializationError(e)  # most likely buffer underfill


  def serialize_numpy(self, buff, numpy):
    """
    serialize message with numpy array types into buffer
    :param buff: buffer, ``StringIO``
    :param numpy: numpy python module
    """
    try:
      _x = self
      buff.write(_get_struct_5d().pack(_x.battery_voltage, _x.charging_voltage, _x.current_12v, _x.current_24v, _x.temperature))
      length = len(self.fault_flags)
      buff.write(_struct_I.pack(length))
      for val1 in self.fault_flags:
        length = len(val1)
        if python3 or type(val1) == unicode:
          val1 = val1.encode('utf-8')
          length = len(val1)
        buff.write(struct.Struct('<I%ss'%length).pack(length, val1))
      _x = self.emergency_stop
      buff.write(_get_struct_B().pack(_x))
    except struct.error as se: self._check_types(struct.error("%s: '%s' when writing '%s'" % (type(se), str(se), str(locals().get('_x', self)))))
    except TypeError as te: self._check_types(ValueError("%s: '%s' when writing '%s'" % (type(te), str(te), str(locals().get('_x', self)))))

  def deserialize_numpy(self, str, numpy):
    """
    unpack serialized message in str into this message instance using numpy for array types
    :param str: byte array of serialized message, ``str``
    :param numpy: numpy python module
    """
    if python3:
      codecs.lookup_error("rosmsg").msg_type = self._type
    try:
      end = 0
      _x = self
      start = end
      end += 40
      (_x.battery_voltage, _x.charging_voltage, _x.current_12v, _x.current_24v, _x.temperature,) = _get_struct_5d().unpack(str[start:end])
      start = end
      end += 4
      (length,) = _struct_I.unpack(str[start:end])
      self.fault_flags = []
      for i in range(0, length):
        start = end
        end += 4
        (length,) = _struct_I.unpack(str[start:end])
        start = end
        end += length
        if python3:
          val1 = str[start:end].decode('utf-8', 'rosmsg')
        else:
          val1 = str[start:end]
        self.fault_flags.append(val1)
      start = end
      end += 1
      (self.emergency_stop,) = _get_struct_B().unpack(str[start:end])
      self.emergency_stop = bool(self.emergency_stop)
      return self
    except struct.error as e:
      raise genpy.DeserializationError(e)  # most likely buffer underfill

_struct_I = genpy.struct_I
def _get_struct_I():
    global _struct_I
    return _struct_I
_struct_5d = None
def _get_struct_5d():
    global _struct_5d
    if _struct_5d is None:
        _struct_5d = struct.Struct("<5d")
    return _struct_5d
_struct_B = None
def _get_struct_B():
    global _struct_B
    if _struct_B is None:
        _struct_B = struct.Struct("<B")
    return _struct_B
