# This Python file uses the following encoding: utf-8
"""autogenerated by genpy from clober_msgs/Feedback.msg. Do not edit."""
import codecs
import sys
python3 = True if sys.hexversion > 0x03000000 else False
import genpy
import struct

import clober_msgs.msg
import std_msgs.msg

class Feedback(genpy.Message):
  _md5sum = "2c328aa11040841210bc311d3725d312"
  _type = "clober_msgs/Feedback"
  _has_header = True  # flag to mark the presence of a Header object
  _full_text = """# Feedback data of robot base controller
Header header

# string robot

# Controller state
clober_msgs/ControllerState controller_state

# Motor state
clober_msgs/MotorState left_motor
clober_msgs/MotorState right_motor
================================================================================
MSG: std_msgs/Header
# Standard metadata for higher-level stamped data types.
# This is generally used to communicate timestamped data 
# in a particular coordinate frame.
# 
# sequence ID: consecutively increasing ID 
uint32 seq
#Two-integer timestamp that is expressed as:
# * stamp.sec: seconds (stamp_secs) since epoch (in Python the variable is called 'secs')
# * stamp.nsec: nanoseconds since stamp_secs (in Python the variable is called 'nsecs')
# time-handling sugar is provided by the client library
time stamp
#Frame this data is associated with
string frame_id

================================================================================
MSG: clober_msgs/ControllerState
# The voltage from the main battery (V)
float64 battery_voltage

# The voltage from the charger (V)
float64 charging_voltage

# The current from the 12V user power (A)
float64 current_12v

# The current from the 24V user power (A)
float64 current_24v

# Internal temperature of the motor controller (C)
float64 temperature 

# The state of the controller fault conditions
string[] fault_flags   

# The state of the emergency stop switch on the controller
bool emergency_stop
================================================================================
MSG: clober_msgs/MotorState
# The actual velocity measured by the encoder as the actual RPM value (rad/s)
float64 velocity

# The actual position by the encoder value (rad)
float64 position

# The current flowing through the motors (A)
float64 current           """
  __slots__ = ['header','controller_state','left_motor','right_motor']
  _slot_types = ['std_msgs/Header','clober_msgs/ControllerState','clober_msgs/MotorState','clober_msgs/MotorState']

  def __init__(self, *args, **kwds):
    """
    Constructor. Any message fields that are implicitly/explicitly
    set to None will be assigned a default value. The recommend
    use is keyword arguments as this is more robust to future message
    changes.  You cannot mix in-order arguments and keyword arguments.

    The available fields are:
       header,controller_state,left_motor,right_motor

    :param args: complete set of field values, in .msg order
    :param kwds: use keyword arguments corresponding to message field names
    to set specific fields.
    """
    if args or kwds:
      super(Feedback, self).__init__(*args, **kwds)
      # message fields cannot be None, assign default values for those that are
      if self.header is None:
        self.header = std_msgs.msg.Header()
      if self.controller_state is None:
        self.controller_state = clober_msgs.msg.ControllerState()
      if self.left_motor is None:
        self.left_motor = clober_msgs.msg.MotorState()
      if self.right_motor is None:
        self.right_motor = clober_msgs.msg.MotorState()
    else:
      self.header = std_msgs.msg.Header()
      self.controller_state = clober_msgs.msg.ControllerState()
      self.left_motor = clober_msgs.msg.MotorState()
      self.right_motor = clober_msgs.msg.MotorState()

  def _get_types(self):
    """
    internal API method
    """
    return self._slot_types

  def serialize(self, buff):
    """
    serialize message into buffer
    :param buff: buffer, ``StringIO``
    """
    try:
      _x = self
      buff.write(_get_struct_3I().pack(_x.header.seq, _x.header.stamp.secs, _x.header.stamp.nsecs))
      _x = self.header.frame_id
      length = len(_x)
      if python3 or type(_x) == unicode:
        _x = _x.encode('utf-8')
        length = len(_x)
      buff.write(struct.Struct('<I%ss'%length).pack(length, _x))
      _x = self
      buff.write(_get_struct_5d().pack(_x.controller_state.battery_voltage, _x.controller_state.charging_voltage, _x.controller_state.current_12v, _x.controller_state.current_24v, _x.controller_state.temperature))
      length = len(self.controller_state.fault_flags)
      buff.write(_struct_I.pack(length))
      for val1 in self.controller_state.fault_flags:
        length = len(val1)
        if python3 or type(val1) == unicode:
          val1 = val1.encode('utf-8')
          length = len(val1)
        buff.write(struct.Struct('<I%ss'%length).pack(length, val1))
      _x = self
      buff.write(_get_struct_B6d().pack(_x.controller_state.emergency_stop, _x.left_motor.velocity, _x.left_motor.position, _x.left_motor.current, _x.right_motor.velocity, _x.right_motor.position, _x.right_motor.current))
    except struct.error as se: self._check_types(struct.error("%s: '%s' when writing '%s'" % (type(se), str(se), str(locals().get('_x', self)))))
    except TypeError as te: self._check_types(ValueError("%s: '%s' when writing '%s'" % (type(te), str(te), str(locals().get('_x', self)))))

  def deserialize(self, str):
    """
    unpack serialized message in str into this message instance
    :param str: byte array of serialized message, ``str``
    """
    if python3:
      codecs.lookup_error("rosmsg").msg_type = self._type
    try:
      if self.header is None:
        self.header = std_msgs.msg.Header()
      if self.controller_state is None:
        self.controller_state = clober_msgs.msg.ControllerState()
      if self.left_motor is None:
        self.left_motor = clober_msgs.msg.MotorState()
      if self.right_motor is None:
        self.right_motor = clober_msgs.msg.MotorState()
      end = 0
      _x = self
      start = end
      end += 12
      (_x.header.seq, _x.header.stamp.secs, _x.header.stamp.nsecs,) = _get_struct_3I().unpack(str[start:end])
      start = end
      end += 4
      (length,) = _struct_I.unpack(str[start:end])
      start = end
      end += length
      if python3:
        self.header.frame_id = str[start:end].decode('utf-8', 'rosmsg')
      else:
        self.header.frame_id = str[start:end]
      _x = self
      start = end
      end += 40
      (_x.controller_state.battery_voltage, _x.controller_state.charging_voltage, _x.controller_state.current_12v, _x.controller_state.current_24v, _x.controller_state.temperature,) = _get_struct_5d().unpack(str[start:end])
      start = end
      end += 4
      (length,) = _struct_I.unpack(str[start:end])
      self.controller_state.fault_flags = []
      for i in range(0, length):
        start = end
        end += 4
        (length,) = _struct_I.unpack(str[start:end])
        start = end
        end += length
        if python3:
          val1 = str[start:end].decode('utf-8', 'rosmsg')
        else:
          val1 = str[start:end]
        self.controller_state.fault_flags.append(val1)
      _x = self
      start = end
      end += 49
      (_x.controller_state.emergency_stop, _x.left_motor.velocity, _x.left_motor.position, _x.left_motor.current, _x.right_motor.velocity, _x.right_motor.position, _x.right_motor.current,) = _get_struct_B6d().unpack(str[start:end])
      self.controller_state.emergency_stop = bool(self.controller_state.emergency_stop)
      return self
    except struct.error as e:
      raise genpy.DeserializationError(e)  # most likely buffer underfill


  def serialize_numpy(self, buff, numpy):
    """
    serialize message with numpy array types into buffer
    :param buff: buffer, ``StringIO``
    :param numpy: numpy python module
    """
    try:
      _x = self
      buff.write(_get_struct_3I().pack(_x.header.seq, _x.header.stamp.secs, _x.header.stamp.nsecs))
      _x = self.header.frame_id
      length = len(_x)
      if python3 or type(_x) == unicode:
        _x = _x.encode('utf-8')
        length = len(_x)
      buff.write(struct.Struct('<I%ss'%length).pack(length, _x))
      _x = self
      buff.write(_get_struct_5d().pack(_x.controller_state.battery_voltage, _x.controller_state.charging_voltage, _x.controller_state.current_12v, _x.controller_state.current_24v, _x.controller_state.temperature))
      length = len(self.controller_state.fault_flags)
      buff.write(_struct_I.pack(length))
      for val1 in self.controller_state.fault_flags:
        length = len(val1)
        if python3 or type(val1) == unicode:
          val1 = val1.encode('utf-8')
          length = len(val1)
        buff.write(struct.Struct('<I%ss'%length).pack(length, val1))
      _x = self
      buff.write(_get_struct_B6d().pack(_x.controller_state.emergency_stop, _x.left_motor.velocity, _x.left_motor.position, _x.left_motor.current, _x.right_motor.velocity, _x.right_motor.position, _x.right_motor.current))
    except struct.error as se: self._check_types(struct.error("%s: '%s' when writing '%s'" % (type(se), str(se), str(locals().get('_x', self)))))
    except TypeError as te: self._check_types(ValueError("%s: '%s' when writing '%s'" % (type(te), str(te), str(locals().get('_x', self)))))

  def deserialize_numpy(self, str, numpy):
    """
    unpack serialized message in str into this message instance using numpy for array types
    :param str: byte array of serialized message, ``str``
    :param numpy: numpy python module
    """
    if python3:
      codecs.lookup_error("rosmsg").msg_type = self._type
    try:
      if self.header is None:
        self.header = std_msgs.msg.Header()
      if self.controller_state is None:
        self.controller_state = clober_msgs.msg.ControllerState()
      if self.left_motor is None:
        self.left_motor = clober_msgs.msg.MotorState()
      if self.right_motor is None:
        self.right_motor = clober_msgs.msg.MotorState()
      end = 0
      _x = self
      start = end
      end += 12
      (_x.header.seq, _x.header.stamp.secs, _x.header.stamp.nsecs,) = _get_struct_3I().unpack(str[start:end])
      start = end
      end += 4
      (length,) = _struct_I.unpack(str[start:end])
      start = end
      end += length
      if python3:
        self.header.frame_id = str[start:end].decode('utf-8', 'rosmsg')
      else:
        self.header.frame_id = str[start:end]
      _x = self
      start = end
      end += 40
      (_x.controller_state.battery_voltage, _x.controller_state.charging_voltage, _x.controller_state.current_12v, _x.controller_state.current_24v, _x.controller_state.temperature,) = _get_struct_5d().unpack(str[start:end])
      start = end
      end += 4
      (length,) = _struct_I.unpack(str[start:end])
      self.controller_state.fault_flags = []
      for i in range(0, length):
        start = end
        end += 4
        (length,) = _struct_I.unpack(str[start:end])
        start = end
        end += length
        if python3:
          val1 = str[start:end].decode('utf-8', 'rosmsg')
        else:
          val1 = str[start:end]
        self.controller_state.fault_flags.append(val1)
      _x = self
      start = end
      end += 49
      (_x.controller_state.emergency_stop, _x.left_motor.velocity, _x.left_motor.position, _x.left_motor.current, _x.right_motor.velocity, _x.right_motor.position, _x.right_motor.current,) = _get_struct_B6d().unpack(str[start:end])
      self.controller_state.emergency_stop = bool(self.controller_state.emergency_stop)
      return self
    except struct.error as e:
      raise genpy.DeserializationError(e)  # most likely buffer underfill

_struct_I = genpy.struct_I
def _get_struct_I():
    global _struct_I
    return _struct_I
_struct_3I = None
def _get_struct_3I():
    global _struct_3I
    if _struct_3I is None:
        _struct_3I = struct.Struct("<3I")
    return _struct_3I
_struct_5d = None
def _get_struct_5d():
    global _struct_5d
    if _struct_5d is None:
        _struct_5d = struct.Struct("<5d")
    return _struct_5d
_struct_B6d = None
def _get_struct_B6d():
    global _struct_B6d
    if _struct_B6d is None:
        _struct_B6d = struct.Struct("<B6d")
    return _struct_B6d
