// Auto-generated. Do not edit!

// (in-package clober_msgs.msg)


"use strict";

const _serializer = _ros_msg_utils.Serialize;
const _arraySerializer = _serializer.Array;
const _deserializer = _ros_msg_utils.Deserialize;
const _arrayDeserializer = _deserializer.Array;
const _finder = _ros_msg_utils.Find;
const _getByteLength = _ros_msg_utils.getByteLength;

//-----------------------------------------------------------

class ControllerState {
  constructor(initObj={}) {
    if (initObj === null) {
      // initObj === null is a special case for deserialization where we don't initialize fields
      this.battery_voltage = null;
      this.charging_voltage = null;
      this.current_12v = null;
      this.current_24v = null;
      this.temperature = null;
      this.fault_flags = null;
      this.emergency_stop = null;
    }
    else {
      if (initObj.hasOwnProperty('battery_voltage')) {
        this.battery_voltage = initObj.battery_voltage
      }
      else {
        this.battery_voltage = 0.0;
      }
      if (initObj.hasOwnProperty('charging_voltage')) {
        this.charging_voltage = initObj.charging_voltage
      }
      else {
        this.charging_voltage = 0.0;
      }
      if (initObj.hasOwnProperty('current_12v')) {
        this.current_12v = initObj.current_12v
      }
      else {
        this.current_12v = 0.0;
      }
      if (initObj.hasOwnProperty('current_24v')) {
        this.current_24v = initObj.current_24v
      }
      else {
        this.current_24v = 0.0;
      }
      if (initObj.hasOwnProperty('temperature')) {
        this.temperature = initObj.temperature
      }
      else {
        this.temperature = 0.0;
      }
      if (initObj.hasOwnProperty('fault_flags')) {
        this.fault_flags = initObj.fault_flags
      }
      else {
        this.fault_flags = [];
      }
      if (initObj.hasOwnProperty('emergency_stop')) {
        this.emergency_stop = initObj.emergency_stop
      }
      else {
        this.emergency_stop = false;
      }
    }
  }

  static serialize(obj, buffer, bufferOffset) {
    // Serializes a message object of type ControllerState
    // Serialize message field [battery_voltage]
    bufferOffset = _serializer.float64(obj.battery_voltage, buffer, bufferOffset);
    // Serialize message field [charging_voltage]
    bufferOffset = _serializer.float64(obj.charging_voltage, buffer, bufferOffset);
    // Serialize message field [current_12v]
    bufferOffset = _serializer.float64(obj.current_12v, buffer, bufferOffset);
    // Serialize message field [current_24v]
    bufferOffset = _serializer.float64(obj.current_24v, buffer, bufferOffset);
    // Serialize message field [temperature]
    bufferOffset = _serializer.float64(obj.temperature, buffer, bufferOffset);
    // Serialize message field [fault_flags]
    bufferOffset = _arraySerializer.string(obj.fault_flags, buffer, bufferOffset, null);
    // Serialize message field [emergency_stop]
    bufferOffset = _serializer.bool(obj.emergency_stop, buffer, bufferOffset);
    return bufferOffset;
  }

  static deserialize(buffer, bufferOffset=[0]) {
    //deserializes a message object of type ControllerState
    let len;
    let data = new ControllerState(null);
    // Deserialize message field [battery_voltage]
    data.battery_voltage = _deserializer.float64(buffer, bufferOffset);
    // Deserialize message field [charging_voltage]
    data.charging_voltage = _deserializer.float64(buffer, bufferOffset);
    // Deserialize message field [current_12v]
    data.current_12v = _deserializer.float64(buffer, bufferOffset);
    // Deserialize message field [current_24v]
    data.current_24v = _deserializer.float64(buffer, bufferOffset);
    // Deserialize message field [temperature]
    data.temperature = _deserializer.float64(buffer, bufferOffset);
    // Deserialize message field [fault_flags]
    data.fault_flags = _arrayDeserializer.string(buffer, bufferOffset, null)
    // Deserialize message field [emergency_stop]
    data.emergency_stop = _deserializer.bool(buffer, bufferOffset);
    return data;
  }

  static getMessageSize(object) {
    let length = 0;
    object.fault_flags.forEach((val) => {
      length += 4 + _getByteLength(val);
    });
    return length + 45;
  }

  static datatype() {
    // Returns string type for a message object
    return 'clober_msgs/ControllerState';
  }

  static md5sum() {
    //Returns md5sum for a message object
    return '46115f277b346cab22c277896530f4f8';
  }

  static messageDefinition() {
    // Returns full string definition for message
    return `
    # The voltage from the main battery (V)
    float64 battery_voltage
    
    # The voltage from the charger (V)
    float64 charging_voltage
    
    # The current from the 12V user power (A)
    float64 current_12v
    
    # The current from the 24V user power (A)
    float64 current_24v
    
    # Internal temperature of the motor controller (C)
    float64 temperature 
    
    # The state of the controller fault conditions
    string[] fault_flags   
    
    # The state of the emergency stop switch on the controller
    bool emergency_stop
    `;
  }

  static Resolve(msg) {
    // deep-construct a valid message object instance of whatever was passed in
    if (typeof msg !== 'object' || msg === null) {
      msg = {};
    }
    const resolved = new ControllerState(null);
    if (msg.battery_voltage !== undefined) {
      resolved.battery_voltage = msg.battery_voltage;
    }
    else {
      resolved.battery_voltage = 0.0
    }

    if (msg.charging_voltage !== undefined) {
      resolved.charging_voltage = msg.charging_voltage;
    }
    else {
      resolved.charging_voltage = 0.0
    }

    if (msg.current_12v !== undefined) {
      resolved.current_12v = msg.current_12v;
    }
    else {
      resolved.current_12v = 0.0
    }

    if (msg.current_24v !== undefined) {
      resolved.current_24v = msg.current_24v;
    }
    else {
      resolved.current_24v = 0.0
    }

    if (msg.temperature !== undefined) {
      resolved.temperature = msg.temperature;
    }
    else {
      resolved.temperature = 0.0
    }

    if (msg.fault_flags !== undefined) {
      resolved.fault_flags = msg.fault_flags;
    }
    else {
      resolved.fault_flags = []
    }

    if (msg.emergency_stop !== undefined) {
      resolved.emergency_stop = msg.emergency_stop;
    }
    else {
      resolved.emergency_stop = false
    }

    return resolved;
    }
};

module.exports = ControllerState;
