// Auto-generated. Do not edit!

// (in-package clober_msgs.msg)


"use strict";

const _serializer = _ros_msg_utils.Serialize;
const _arraySerializer = _serializer.Array;
const _deserializer = _ros_msg_utils.Deserialize;
const _arrayDeserializer = _deserializer.Array;
const _finder = _ros_msg_utils.Find;
const _getByteLength = _ros_msg_utils.getByteLength;
let ControllerState = require('./ControllerState.js');
let MotorState = require('./MotorState.js');
let std_msgs = _finder('std_msgs');

//-----------------------------------------------------------

class Feedback {
  constructor(initObj={}) {
    if (initObj === null) {
      // initObj === null is a special case for deserialization where we don't initialize fields
      this.header = null;
      this.controller_state = null;
      this.left_motor = null;
      this.right_motor = null;
    }
    else {
      if (initObj.hasOwnProperty('header')) {
        this.header = initObj.header
      }
      else {
        this.header = new std_msgs.msg.Header();
      }
      if (initObj.hasOwnProperty('controller_state')) {
        this.controller_state = initObj.controller_state
      }
      else {
        this.controller_state = new ControllerState();
      }
      if (initObj.hasOwnProperty('left_motor')) {
        this.left_motor = initObj.left_motor
      }
      else {
        this.left_motor = new MotorState();
      }
      if (initObj.hasOwnProperty('right_motor')) {
        this.right_motor = initObj.right_motor
      }
      else {
        this.right_motor = new MotorState();
      }
    }
  }

  static serialize(obj, buffer, bufferOffset) {
    // Serializes a message object of type Feedback
    // Serialize message field [header]
    bufferOffset = std_msgs.msg.Header.serialize(obj.header, buffer, bufferOffset);
    // Serialize message field [controller_state]
    bufferOffset = ControllerState.serialize(obj.controller_state, buffer, bufferOffset);
    // Serialize message field [left_motor]
    bufferOffset = MotorState.serialize(obj.left_motor, buffer, bufferOffset);
    // Serialize message field [right_motor]
    bufferOffset = MotorState.serialize(obj.right_motor, buffer, bufferOffset);
    return bufferOffset;
  }

  static deserialize(buffer, bufferOffset=[0]) {
    //deserializes a message object of type Feedback
    let len;
    let data = new Feedback(null);
    // Deserialize message field [header]
    data.header = std_msgs.msg.Header.deserialize(buffer, bufferOffset);
    // Deserialize message field [controller_state]
    data.controller_state = ControllerState.deserialize(buffer, bufferOffset);
    // Deserialize message field [left_motor]
    data.left_motor = MotorState.deserialize(buffer, bufferOffset);
    // Deserialize message field [right_motor]
    data.right_motor = MotorState.deserialize(buffer, bufferOffset);
    return data;
  }

  static getMessageSize(object) {
    let length = 0;
    length += std_msgs.msg.Header.getMessageSize(object.header);
    length += ControllerState.getMessageSize(object.controller_state);
    return length + 48;
  }

  static datatype() {
    // Returns string type for a message object
    return 'clober_msgs/Feedback';
  }

  static md5sum() {
    //Returns md5sum for a message object
    return '2c328aa11040841210bc311d3725d312';
  }

  static messageDefinition() {
    // Returns full string definition for message
    return `
    # Feedback data of robot base controller
    Header header
    
    # string robot
    
    # Controller state
    clober_msgs/ControllerState controller_state
    
    # Motor state
    clober_msgs/MotorState left_motor
    clober_msgs/MotorState right_motor
    ================================================================================
    MSG: std_msgs/Header
    # Standard metadata for higher-level stamped data types.
    # This is generally used to communicate timestamped data 
    # in a particular coordinate frame.
    # 
    # sequence ID: consecutively increasing ID 
    uint32 seq
    #Two-integer timestamp that is expressed as:
    # * stamp.sec: seconds (stamp_secs) since epoch (in Python the variable is called 'secs')
    # * stamp.nsec: nanoseconds since stamp_secs (in Python the variable is called 'nsecs')
    # time-handling sugar is provided by the client library
    time stamp
    #Frame this data is associated with
    string frame_id
    
    ================================================================================
    MSG: clober_msgs/ControllerState
    # The voltage from the main battery (V)
    float64 battery_voltage
    
    # The voltage from the charger (V)
    float64 charging_voltage
    
    # The current from the 12V user power (A)
    float64 current_12v
    
    # The current from the 24V user power (A)
    float64 current_24v
    
    # Internal temperature of the motor controller (C)
    float64 temperature 
    
    # The state of the controller fault conditions
    string[] fault_flags   
    
    # The state of the emergency stop switch on the controller
    bool emergency_stop
    ================================================================================
    MSG: clober_msgs/MotorState
    # The actual velocity measured by the encoder as the actual RPM value (rad/s)
    float64 velocity
    
    # The actual position by the encoder value (rad)
    float64 position
    
    # The current flowing through the motors (A)
    float64 current           
    `;
  }

  static Resolve(msg) {
    // deep-construct a valid message object instance of whatever was passed in
    if (typeof msg !== 'object' || msg === null) {
      msg = {};
    }
    const resolved = new Feedback(null);
    if (msg.header !== undefined) {
      resolved.header = std_msgs.msg.Header.Resolve(msg.header)
    }
    else {
      resolved.header = new std_msgs.msg.Header()
    }

    if (msg.controller_state !== undefined) {
      resolved.controller_state = ControllerState.Resolve(msg.controller_state)
    }
    else {
      resolved.controller_state = new ControllerState()
    }

    if (msg.left_motor !== undefined) {
      resolved.left_motor = MotorState.Resolve(msg.left_motor)
    }
    else {
      resolved.left_motor = new MotorState()
    }

    if (msg.right_motor !== undefined) {
      resolved.right_motor = MotorState.Resolve(msg.right_motor)
    }
    else {
      resolved.right_motor = new MotorState()
    }

    return resolved;
    }
};

module.exports = Feedback;
